import numpy as np
from sklearn.naive_bayes import MultinomialNB

from sklearn.feature_extraction.text import TfidfVectorizer
from sklearn.feature_extraction.text import HashingVectorizer

from sklearn.datasets.base import load_files
from sklearn import metrics
#from copy import deepcopy
import random

print ' Treatments classification - Eric'

documents = load_files('../data/', encoding='utf-8')
n = len(documents.data)
indx = range(n)
random.shuffle(indx)
n_test = int(n/3)
i_test = indx[1:n_test]
i_train = indx[n_test:]
#i_test =

vectorizer = TfidfVectorizer(sublinear_tf=True, max_df=0.5)
#stop_words='english')

d_train = [documents.data[i] for i in i_train]
d_test = [documents.data[i] for i in i_test]

X_train = vectorizer.fit_transform(d_train)
X_test = vectorizer.transform(d_test)
y_train = [documents.target[i] for i in i_train]
y_test = np.array([documents.target[i] for i in i_test])

# X = np.random.randint(5, size=(6, 100))
# y = np.array([1, 2, 3, 4, 5, 6])

clf = MultinomialNB(alpha=0.01)
clf.fit(X_train, y_train)
pred = clf.predict(X_test)
score = metrics.f1_score(y_test, pred)
print("Size training dataset: %d" % len(d_train))
print("Size test dataset: %d" % len(d_test))
print("f1-score:   %0.3f" % score)

##
for i in range(len(documents.target_names)):
    print documents.target_names[i]
    idx = np.where(y_test == i)
    print pred[idx]
